local mod = ...



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Performer1.fbx/Prefab/ActorMaleFront", "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT")
mod:registerAssetId("models/Performer1.fbx/Prefab/ActorMaleBelt", "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT")

mod:registerAssetId("models/Performer1.fbx/Prefab/ActorFemaleFront", "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT")
mod:registerAssetId("models/Performer1.fbx/Prefab/ActorFemaleBelt", "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT")

-- mod:registerAssetId("models/Performer1.fbx/Prefab/StagePart", "PREFAB_ENTERTAINMENT_STAGE_FRAME")
-- mod:registerAssetId("models/Performer1.fbx/Prefab/StageSpotPart1", "PREFAB_ENTERTAINMENT_STAGE_SPOT1")
-- mod:registerAssetId("models/Performer1.fbx/Prefab/StageSpotPart2", "PREFAB_ENTERTAINMENT_STAGE_SPOT2")



-- Job: Actor -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_ACTOR",
	JobName = "JOB_ENTERTAINMENT_ACTOR_NAME",
	JobDescription = "JOB_ENTERTAINMENT_ACTOR_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        },
        FemaleBeltList = {
            "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        },
        MaleBeltList = {
            "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_ACTOR"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_ACTOR"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_ACTOR"
    }
})



-- Building Function: Actor -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_ACTOR",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_ACTOR_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ENTERTAINMENT_ACTOR", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 20,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 5 },
	}
})



-- -- Building Part: Stage Frame -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ENTERTAINMENT_STAGE_FRAME",
-- 	Name = "BUILDING_PART_ENTERTAINMENT_STAGE_FRAME_NAME", 
-- 	Description = "BUILDING_PART_ENTERTAINMENT_STAGE_FRAME_DESC",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
-- 		CoreRandomBuildingPartList = { "PREFAB_ENTERTAINMENT_STAGE_FRAME" },
-- 		-- CoreRandomBuildingPartList = { "PREFAB_STAGE_PART" },
-- 		MandatoryBuildingPartList = {
-- 			{ BuildingPart = "STAGE_PART", OptionalAttachNodeString = "Attach_Major.Stage" },
-- 			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT1", OptionalAttachNodeString = "Attach_Major.Spot1" },
-- 			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT2", OptionalAttachNodeString = "Attach_Major.Spot2" },
-- 			-- { BuildingPart = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT1", OptionalAttachNodeString = "Attach_Right.006" },
-- 			-- { BuildingPart = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT2", OptionalAttachNodeString = "Attach_Major.007" },
-- 		}
-- 	},
-- 	-- BuildingZone = { 
--     --     ZoneEntryList = {
--     --         { 
--     --             Polygon = polygon.createRectangle( {7, 6}, {0, 0} ),
--     --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
-- 	-- 		},
-- 	-- 	}
-- 	-- },
-- 	Cost = {
--         -- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } }
--         -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
--         -- RessourcesNeeded = {
--         --     { Resource = "WOOD", Quantity = 10 },
-- 		-- }
-- 	}
-- })



-- -- Building Part: Actor Spot 1 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT1",
-- 	Name = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT1_NAME", 
-- 	Description = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT1_DESC",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STAGE_SPOT1"
-- 	},
-- 	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_ACTOR"
-- 	-- BuildingZone = { 
--     --     ZoneEntryList = {
--     --         { 
--     --             Polygon = polygon.createRectangle( {7, 6}, {0, 0} ),
--     --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
-- 	-- 		},
-- 	-- 	}
-- 	-- },
-- 	-- Cost = {
--     --     BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } }
--     --     -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
--     --     -- RessourcesNeeded = {
--     --     --     { Resource = "WOOD", Quantity = 10 },
-- 	-- 	-- }
-- 	-- }
-- })



-- -- Building Part: Actor Spot 2 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT2",
-- 	Name = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT2_NAME", 
-- 	Description = "BUILDING_PART_ENTERTAINMENT_STAGE_SPOT2_DESC",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STAGE_SPOT2"
-- 	},
-- 	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_ACTOR",
-- 	-- BuildingZone = { 
--     --     ZoneEntryList = {
--     --         { 
--     --             Polygon = polygon.createRectangle( {7, 6}, {0, 0} ),
--     --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
-- 	-- 		},
-- 	-- 	}
-- 	-- },
-- 	-- Cost = {
--     --     BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } }
--     --     -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
--     --     -- RessourcesNeeded = {
--     --     --     { Resource = "WOOD", Quantity = 10 },
-- 	-- 	-- }
-- 	-- }
-- })



-- Building Part: Stage (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "STAGE_PART",
	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_ACTOR",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 100 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 50 } },
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 6 },
			{ Resource = "PLANK", Quantity = 10 },
		}
	}
})



-- Building Part: Stairs (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "STAIRS_WOODEN_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Stands (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "STANDS_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 6 },
			{ Resource = "PLANK", Quantity = 10 },
		}
	}
})



-- Building Part: Stands (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "STANDS_COVERED_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 6 },
			{ Resource = "PLANK", Quantity = 10 },
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Gate (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "GATE_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Gate (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "GATE_ROPE_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_RED_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_ORANGE_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_GREEN_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_BLUE_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_TEAL_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})



-- Building Part: Backdrop (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BACKDROP_PURPLE_PART",
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
		}
	}
})
